unit lfsc_com_1;
interface
uses
  ComObj,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Buttons, ComCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    SpeedButton1: TSpeedButton;
    Edit_Init: TEdit;
    Label1: TLabel;
    Panel2: TPanel;
    Edit_1C8_Name: TEdit;
    GroupBox1: TGroupBox;
    Panel3: TPanel;
    SpeedButton2: TSpeedButton;
    ListBox1: TListBox;
    Label3: TLabel;
    ComboBox1: TComboBox;
    Label_YesConnect: TLabel;
    Label2: TLabel;
    procedure SpeedButton1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure SpeedButton2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    s1C8_ole : Variant; //  1Cv8

  end;

var
  Form1: TForm1;


//  1Cv8 (COM)
function ConnectTo1C8_COM(s1cAppProgID,InitLine : string) : Variant;
//,    (HandleAny)
function YesLinkToVariant(HandleAny : Variant) : boolean;


implementation

{$R *.DFM}


procedure TForm1.FormCreate(Sender: TObject);
begin
  //
  s1C8_ole:=UnAssigned;
  Edit_1C8_Name.Text:='V8.COMConnector';
  Edit_Init.Text:='File=F:\1Cv8.DB\HomeLib';
  ComboBox1.ItemIndex:=0;
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  CanClose:=true;
  s1C8_ole:=UnAssigned;
end;


procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  s1C8_ole:=UnAssigned;
  Label_YesConnect.Visible:=false;
  ListBox1.Items.Clear;
  //  1Cv8
  s1C8_ole:=ConnectTo1C8_COM(Trim(Edit_1C8_Name.Text),Trim(Edit_Init.Text));
  if YesLinkToVariant(s1C8_ole) then begin
     Label_YesConnect.Visible:=true;
  end
  else begin
     ShowMessage('');
  end;
end;


procedure TForm1.SpeedButton2Click(Sender: TObject);
//    
Var
  Sel_ole, //   
  SbCnt_ole  : Variant; //   "."
  Yes : byte;
begin
  SbCnt_ole:=UnAssigned;
  Sel_ole:=UnAssigned;
  ListBox1.Items.Clear;

  //,     1Cv8
  if YesLinkToVariant(s1C8_ole) then begin

     //      -  ""
     SbCnt_ole:=s1C8_ole..;
     //SbCnt_ole:=s1C8_ole.NewObject('.');

     //    
     Sel_ole := SbCnt_ole.();

     //  
     while Sel_ole.() do
      begin

       Yes:=0;
       // 
       if ComboBox1.ItemIndex<=0 then Yes:=1;

       if ComboBox1.ItemIndex=1 then begin
          //  
          if not Sel_ole. then Yes:=1;
       end;

       if ComboBox1.ItemIndex>=2 then begin
          //  
          if Sel_ole. then Yes:=1;
       end;

       if Yes>0 then begin
          if not Sel_ole. then begin
             //  
             ListBox1.Items.Add('    '+Trim(Sel_ole.)+'='+Trim(Sel_ole.));
          end
          else begin
             //   
             ListBox1.Items.Add('=> '+Trim(Sel_ole.)+'='+Trim(Sel_ole.));
          end;
       end;

     end;

  end
  else begin
     ShowMessage('     1Cv8 !');
  end;
end;


function ConnectTo1C8_COM(s1cAppProgID,InitLine : string) : Variant;
//  1Cv8 (COM)
{
//s1cAppProgID -  . COM-  1Cv8 (  )
   V8.COMConnector
InitLine ( ) :
    .. :
    File=\Trade
    Usr=
    Pwd=
  -  .. :
    Srvr=Server1C ( ,     1)
    Ref=Trade (      1)
    Usr=
    Pwd=
}
//  :   . COM-  1Cv8
//                          Unassigned (  )
begin
  Result:=Unassigned;
  s1cAppProgID:=Trim(s1cAppProgID);
  if Length(s1cAppProgID)<=0 then s1cAppProgID:='V8.COMConnector';
  InitLine:=Trim(InitLine);
  if Length(s1cAppProgID)>0 then begin
     // 
     Result := CreateOleObject(s1cAppProgID);
     //  
     if YesLinkToVariant(Result) then begin
        //  1Cv8     COM-
        Result:=Result.Connect(InitLine);
        if not YesLinkToVariant(Result) then Result:=Unassigned;
     end;
  end;
end;




function YesLinkToVariant(HandleAny : Variant) : boolean;
//,    (HandleAny)
begin
 Result:=FALSE;
 if not VarIsEmpty(HandleAny) then Result:=TRUE;
end;



end.





